/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>

using namespace std;

int maxRoad = 0, squares;
vector<int> * roadNums;

inline bool containsOnce(int sq1, int num)
{
    bool temp = false;
    for(int i = 0; i < roadNums[sq1].size(); i++)
        if(roadNums[sq1][i] == num)
        {
            if(temp) return false;
            temp = true;
        }
    return temp;
}

inline int insertRoad(int index)
{
    for(int i = 0; i < squares; i++)
        if(containsOnce(index, i))
        {
            roadNums[index].push_back(i);
            return i;
        }
    maxRoad++;
    roadNums[index].push_back(maxRoad);
    return maxRoad;
}

int main()
{
    ifstream in("streets.in");
    ofstream out("streets.out");
    int roads, sq1, sq2;
    in >> squares;
    in >> roads;

    roadNums = new vector<int>[squares]();
    for(int i = 0; i < roads; i++)
    {
        in >> sq1;
        in >> sq2;
        sq1--;
        sq2--;
        roadNums[sq2].push_back(insertRoad(sq1));
    }

    out << maxRoad << "\n";
    in.close();
    out.close();
    delete[] roadNums;
    return 0;
}
